+++
title = "Home Assistant : Projet Consonance"
date = 2025-07-18
[taxonomies]
tags = [ "système", "home assistant", "infrarouge", "logitech harmony", "consonance" ]
+++

> « Hail to the King, baby! »

*Duke Nukem ou quelque chose, je sais pas, j’ai pas joué au jeu*

<!-- more -->

# Le roi est mort, vive… ah attendez…

Pour ceux qui ne seraient pas au courant, [Logitech](https://www.logitech.com/fr-fr) a annoncé, il y a déjà quelques années, que les télécommandes de la série [Harmony](https://www.myharmony.com/fr-fr/) s’arrêtait.

Non seulement, Logitech ne va plus les vendre, mais en plus, **les serveurs seront éteints courant de l’année 2025**. Or, nous sommes courant de l’année 2025 et certains serveurs sont effectivement déjà éteints, notamment celui de [l’application historique de Logitech](https://members.harmonyremote.com/EasyZapper/) sur lequel s’appuyait notamment le projet [Concordance](https://github.com/jaymzh/concordance) qui permettait aux utilisateurs de Linux de mettre à jour leur télécommande.

L’application Windows, écrite avec [Microsoft Silverlight](https://fr.wikipedia.org/wiki/Silverlight), non, non, ce n’est pas une blague, continue de fonctionner mais avec un nombre de télécommandes bien plus limitées et pour un temps probablement lui aussi très limité.

L’arrêt de serveurs ne transforme pas instantannément toutes les télécommandes Harmony en presse-papier. Elles ont été conçues au début des annnées 2000, période à laquelle il n’était pas forcément possible que tout appareil puisse être connecté.

Autrement dit, si tu as une télécommande Harmony, la bonne nouvelle c’est qu’elle fonctionne toujours. La mauvaise, c’est que si tu dois y effectuer le moindre changement, ajouter un appareil ou modifier une commande, et bien tu l’as dans l’os.

# Les alternatives

L’arrêt ayant été annoncé en 2021, tu pourrais penser que des concurrents reprennent le flambeau. Et bien malheureusement, ça ne se passe pas tout-à-fait comme ça… Je te propose de jeter un petit coup d’œil à ce qui pourrait remplacer une télécommande Harmony en 2025.

## HDMI CEC

Le concurrent n°1, c’est évidemment… la norme HDMI elle-même ! Nous sommes en 2025 et la plupart des gens ont des appareils connectés de manière numérique et utilisant une norme permettant le transfert de l’image, du son **et des commandes**.

Ça s’appelle le [HDMI CEC](https://fr.wikipedia.org/wiki/Consumer_Electronics_Control) et, tant qu’on ne lui en demande pas trop, ça « marche ». Alors soyons très clair, si t’as effectivement une télévision, une barre de son, une Nintendo Switch et un boîtier TV quelconque, ça marche.

Par contre, dès que tu commences à intégrer des appareils n’ayant pas de CEC, ou simplement que ton installation est plus compliquée que cela et bien ça merde dans les grandes largeurs. Le CEC a été conçu pour des cas simples avec des appareils à fonctions bien définies et uniques. Dès que l’on rajoute ne serait-ce qu’un Switch HDMI, ça commence généralement à partir en couille.

Sans compter le fait qu’il est toujours compliqué de déterminer qui allume qui, qui éteint qui, etc…

Bref, je pense que c’est **la raison** qui fait que Logitech a abandonné les télécommandes Harmony : avec le CEC, pour 90% des usages, c’est largement suffisant, sa télécommande ne se justifiait plus que pour un marché de niche, voire d’ultra-niche. Mais il n’empêche que pour les gens qui ont besoin de contrôler plus de choses, le CEC est plus un cauchemar qu’autre chose.

## SofaBaton

Présenté par certains comme **LA** solution à la défection de Logitech, [Sofabaton](https://www.sofabaton.com/), malgré son nom ridicule, est effectivement un sérieux concurrent. Une télécommande qui a l’air bien foutue, une liste de compatibilité longue comme… enfin une très longue liste, et un appareil qui lui-même semble plutôt costaud et sympathique à utiliser.

Sofabaton présente aussi l’avantage de proposer un hub, façon [Harmony Hub](https://support.myharmony.com/fr-fr/hub) sur certains modèles. Le hub, c’est un truc à la con, mais quand on commande des appareils infrarouge, il faut obligatoirement avoir une ligne de vue vers les appareils en question. En fonction de comment est organisé ton salon et tes appareils, ça peut éventuellement être compliqué d’avoir systématiquement **tout** en ligne de mire pour lancer une commande. Donc on retiendra que le Hub, c’est plutôt une bonne idée dans l’absolu, surtout qu’il dispose de sorties infrarouge supplémentaires au cas où.

Par contre, toutes les Sofabaton ne naissent pas égales. Les modèles [U2](https://www.sofabaton.com/products/u2/) ne fonctionnent pas ainsi selon le principe d’Activités qui a rendu les Logitech Harmony célèbres : tu appuies sur le bouton DVD, ça allume télé, les enceintes, l’ampli, le lecteur DVD lui-même et ça met toutes les bonnes entrées sur tout ce petit monde. Sans cela, et bien on a juste regroupé toutes les télécommandes en une, mais on n’a pas vraiment simplifié la façon de fonctionner de l’ensemble. Fort heureusement, les X1 et [X1S](https://www.sofabaton.com/products/x1s/) corrige le tir en prévoyant un fonctionnement par activité.

Autre problème : le prix. Quelques fois disponibles pour un peu moins de 200€, bah ça fait quand même 200€. Alors certes, les télécommandes Harmony ont toujours été assez chères aussi. En prenant compte de l’inflation, je pense qu’une Harmony One devait facilement coûter 300€. Mais la proposition de valeur n’est plus tout-à-fait la même aujourd’hui.

Mais en fait, le vrai gros point noir c’est la configuration. Elle se fait toujours avec une appli, sur mobile cette fois, et cette appli, elle pourrait bien s’arrêter dans quelques années, voire quelques mois. Et j’ai déjà donné, donc non merci…

## Unfolded Circle Remote Two/3

[Unfolded Circle](https://www.unfoldedcircle.com/), en dehors d’avoir un nom à coucher dehors, ça a l’air d’être des gens bien. Et leur produit, c’est effectivement un avion de chasse : configuration locale à 100%, plusieurs milliers d’appareils supportés, Bluetooth, gyroscope, *air-mouse*, chargement par induction, etc…

C’est un truc de gros furieux avec en plus un dock, des relais infrarouges, etc… Et en plus, une API ouverte et plein d’autres trucs. On peut a priori y faire tout et surtout n’importe quoi avec à peu près n’importe quel appareil.

Le problème… c’est le prix. À 399€, la télécommande seule, 499€ avec le dock, c’est quand même putain de pas donné ! La Rolls Royce des télécommandes, à n’en pas douter, mais clairement une solution bien au-delà de mes moyens pour un truc de ce type.

# Bricole picole a.k.a. Projet Consonance

![img](/2025/07/harmony_unfolded.jpg)

L’autre alternative. Et bien, c’est Home Assistant.

En fait, Home Assistant a déjà presque tout ce qu’il faut pour remplacer une télécommande Harmony : des scripts, des entités virtuelles et des intégrations de folie. On peut déjà y coller une TV connectée si on le souhaite, un Kodi, un Nvidia Shield, etc…

Donc en théorie, on peut déjà contrôler pas mal de trucs si on fait exception de tout ce qui est infrarouge.

## Blaste cet infrarouge !

Mais il se trouve qu’on peut aussi y coller un *IR Blaster*. C’est un petit appareil dont la seule utilité est de balancer des éléments infrarouge qu’on lui aura précédemment appris. Il en existe de nombreux : connecté à une application ou pas, en Zigbee, en Z-Wave, sur pile, sur batterie, etc… C’est presque sûr qu’on peut trouver de quoi faire son bonheur. Personnellement, j’ai opté pour le [Broadlink RM4 Pro](https://ebroadlink.com/products/universal-remote-rm4-pro).

Il vient avec une application qui permet de faire le premier paramétrage et après… on peut l’en détacher complètement et s’en servir directement dans Home Assitant. Il est en Wi-Fi et prend deux commandes très simple : `learn_command` pour apprendre une commande existante et `send_command` pour envoyer une commande existante.

Alors effectivement, quand on le déconnecte de son appli, il faut se taper l’apprentissage de toutes les commandes via les télécommandes d’origine ou via la Logitech Harmony encore opérationnelle. Mais l’intérêt derrière, c’est que c’est un simple fichier JSON avec des informations assez simple : quel appareil, quelle commande, quel signal.

Donc changer d’appareil pour envoyer des commandes, rien de plus simple en réalité.

Une fois le RM4 Pro intégré dans Home Assistant, via l’intégration Broadlink, l’apprentissage se fait en passant par le menu `Outils de développement`, dans `Actions`. 

Voici un exemple :

![img](/2025/07/dev_learn_command_ha.png)

C’est un peu pénible à faire, mais j’en ai eu pour à peu près une heure pour rentrer 5 télécommandes. Le plus relou restant les commandes qui n’existent pas sur la télécommande d’origine. Par exemple, ma télévision LG OLED peut aller directement sur la bonne entrée (`HDMI1`, `HDMI2`, etc…) mais ce n’est pas une touche en accès direct. Il a donc fallu que je repasse par ma Logitech Harmony pour apprendre tout ça au Broadlink.

## Scripts

Maintenant qu’on a appris toutes les commandes, il reste à voir commander les ordonnancer proprement pour chaque activité. Et là, un second problème pointe son nez : quand on fait de l’infrarouge, on ne peut pas vraiment savoir si l’appareil a reçu la commande correctement ou non : on blaste les commandes suffisamment fort en espérant que ça passe.

![img](/2025/07/blasting.jpg)

Et le second souci à coupler à ce premier : la plupart des appareils infrarouge ont un seul et unique bouton pour allumer et éteindre. C’est un `power_toggle`. Il est assez rare d’avoir une commande d’allumage et une commande d’extinction. Cela veut dire que l’on doit mémoriser quelque part l’état de l’appareil histoire de ne pas tout éteindre/tout allumer aléatoirement tout le temps.

> Note : l’intégration Broadlink comprend une notion de [communateur (switch)](https://www.home-assistant.io/integrations/broadlink/#setting-up-custom-irrf-switches) qui permet de créer des interrupteurs virtuels. Si on possède effectivement une commande d’allumage et une command d’extinction, ça marche plutôt bien. Malheureusement, c’est rarement le cas.

Pour ce faire, j’ai créé des entités virtuelles représentant les différents appareils que je souhaite contrôler. Ce sont des simples interrupteurs (*on/off*) mais on pourrait imaginer de stocker plus d’informations que cela (par exemple la dernière entrée d’un appareil).

Donc dans `Paramètres` > `Appareils et services` > `Entrées`, j’ai créé les 6 appareil contrôlés en infrarouge. Pour des raisons pratiques, je vais considérer que Kodi est contrôlé via son API (ce sera bien plus simple). Je leur ai tous donné une zolie icône et mis dans une catégorie `Consonance`, puisque ce sera le nom de ce projet. Concrètement, ça donne ça :

![img](/2025/07/home_assistant_config_helpers.png)

Partant de là, c’est relativement simple : un script pour chaque activité et un script d’extinction. Pour l’instant, je ne souhaite pas compliquer les choses en permettant de passer d’une activité à une autre, comme mon Harmony savait le faire. Cela pourra venir plus tard, ce n’est pas particulièrement complexe à faire, ça demande juste un peu plus de temps pour pas grand-chose.

Dans le script d’activité :
* on envoie la commande `power_toggle` tous les appareils qui vont bien (TV, enceintes, etc…)
* on allume toutes les entrées logiques correspondantes pour garder la mémoire de ce qui est allumé
* on attend (5 secondes en général)
* on envoie toutes les commandes d’entrée qui vont bien sur les appareils allumés

Et boum ! On a une activité qui roule. Plus l’activité implique d’appareils, plus les temps d’attente vont varier, mais ce n’est pas beaucoup plus lourd que ça à gérer.

Pour l’extinction générale pareil, assez simple, pour chaque entrée logique :
* on vérifie si elle est allumé
* on envoie la commande `power_toggle`
* on éteint l’entrée logique

Avec le langage de script d’Home Assistant, il est difficile de faire des boucles, mais on peut faire des groupes ou traiter tous les appareils indépendamment. On pourrait donc très bien imaginer mettre les appareils dans un groupe ou une catégorie en fonction de l’activité et simplement s’appuyer là-dessus pour gérer la partie interrupteur virtuelle.

Si l’on veut éviter le gros gloubiboulga en basculant d’une activité à l’autre, on peut forcer le passage par le script d’extinction. Pour cela, il suffit de rajouter une autre entrée logique permettant de dire qu’un activité est en cours (ou prendre une entrée logique existant dont on sait qu’elle est toujours allumée) et d’ajouter une condition au début de l’exécution de chaque script d’activité pour arrêter sa propre exécution si l’entrée logique en question est *on*. Ça rajoute encore une petite couche de logique un peu reloue à gérer, mais c’est le prix à payer.

Si l’on souhaitait éviter ce comportement et passer d’une activité à une autre en passant par les mêmes scripts, il faudrait revenir à ce que l’on disait plus haut : grouper les interrupteurs virtuels pour garder un état cohérent.

Sachant que, de toutes manières, on ne pourra jamais vraiment avoir l’état complet du système… tout comme avec les Logitech Harmony !

# Conclusage

Là, on a plutôt fait la partie arrière-boutique. La prochaine fois, on verra comment interagir avec Home Assistant pour tout contrôler. En attendant, je te laisse avec [le repo qui va bien](https://giteu.be/home_assitant/consonance) si tu veux repomper le truc ou t’inspirer.
